//
//  COComplexArray.h
//  CoherentOptics
//
//  Created by Don Cottrell on 4/8/05.
//  Copyright 2005 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "CODocument.h"
#import "CODocWinController.h"
#import <Accelerate/Accelerate.h>

typedef struct {
				float r;
				float i; } Fcomplex;

typedef struct {
				double r;
				double i; } Dcomplex;

@interface COComplexArray : NSObject {
	int num;
	NSMutableData *realPart;
	NSMutableData *imPart;
	id coWinC;
	id theDoc;
	int nPower;
	FFTSetupD 		setupFFT,setupFFTBig;
	double ttop;
    double actualTop;
	int wtable[4096];
	NSDate * startDate, * finishDate; // for Fourier transform timing
	int forward;  // used because of threading of Fourier 
	id fourierSenderMod; // also for threading
	id fourierOversizeSenderMod;
	id RtoPSenderMod;
	id PtoRSenderMod;
    id multiplySenderMod;
}
- (id)initWithNum:(int)N;
- (void)setNum:(int)n;
- (NSMutableData *)realPart;
- (NSMutableData *)imPart;
- (double)ttop;
- (double)actualTop;
- (void)setTtop:(double)x;
//- (void)unravelFileDataAndReorder:(NSData *)theData;
- (void)unravelFileData:(NSData *)theData;
- (void)unravelLEFFileData:(NSData *)theData;
- (void) separateOddData:(NSData *)fileData 
				intoReal:(NSMutableData *)realP 
			andImaginary:(NSMutableData *)imP;
-(void) separateOddLEFData:(NSData *)fileData
                  intoReal:(NSMutableData *)realP
              andImaginary:(NSMutableData *)imP;
- (void)unravelOddSizeData:(NSData *)fileData;
-(void) unravelOddSizeLEFData:(NSData *)fileData;
-(void) unravelOddSizeLEDataD:(NSData *)fileData;
- (void)unravelFileDataD:(NSData *)theData;
- (void) separateOddDataD:(NSData *)fileData 
				intoReal:(NSMutableData *)realP 
			andImaginary:(NSMutableData *)imP;
- (void) separateLEDataD:(NSData *)fileData
                intoReal:(NSMutableData *)realP
            andImaginary:(NSMutableData *)imP;
- (void)unravelOddSizeDataD:(NSData *)fileData;
- (void)setTheDoc:(id)x;
- (void)setCoWinC:(id)x;
- (NSMutableData*)sendRealPart:(id)sender;
- (NSMutableData*)sendImagPart:(id)sender;
- (NSMutableData*)sendMag:(id)sender;
- (NSMutableData*)sendMagSq:(id)sender;
- (NSMutableData*)sendPhase:(id)sender;
- (void)oneDimFourier:(int)forwards  module:(id)amod;
- (void)oneDimHFourier:(int)forwards  module:(id)amod;
- (void)end1DFourier;
- (void)fourierTransform:(int)frd module:(id)aMod;
#ifdef __LITTLE_ENDIAN__
- (void)theFourierColumns;
- (void)endFourier;
- (void)doneWithRtoPThread;
#endif
//- (void)swapa;
//- (void)swapm;
- (void)compConj;
- (void)enterF:(unsigned char*)x flag:(float)s;
- (void)enterAdd1_0:(unsigned char*)x;
- (double)realPartAtX:(int)x Y:(int)y;
- (double)imaginaryPartAtX:(int)x Y:(int)y;
- (void)addToReal:(NSMutableData *)x imag:(NSMutableData *)y;
- (void)mutiplybyReal:(NSMutableData *)x imag:(NSMutableData *)y;
- (void)multiplybyReal:(NSMutableData*)x imag:(NSMutableData*)y mod:(id)aMod;
- (void)replaceReal:(NSMutableData *)x imag:(NSMutableData *)y;
- (void)buildZPFwithPhaseBase:(double)phaseBase
					conjugate:(int)conjFlag
					 multiply:(int)multiplyFlag
                         duel:(int)duelFlag
				   horizontal:(int)xFlag
					 vertical:(int)yFlag
					  xoffset:(float)dx
					  yoffset:(float)dy ;
- (void)non_parPhaseReal:(NSMutableData *)x Imag:(NSMutableData *)y a:(double)a b:(double)b;
- (void)timesI;
- (void)rescaleWithMR:(double)mr MI:(double)mi AR:(double)ar AI:(double)ai;
- (void)multiplyBigRightSize:(NSData *)Data;
- (void)addBigRightSize:(NSData *)theData;
- (void)multiplyByBitmap:(unsigned char *)bitmapBytes;
- (void)multiplyByBitmap1_1:(unsigned char *)bitmapBytes;
- (NSData *)shuffleDataTogether;
- (NSData *)shuffleLEFDataTogether;
- (NSData *)shuffleDoubleDataTogether;
- (NSData *)shuffleLEDoubleDataTogether;
- (void)phaseOnly;
- (void)magSquared;
- (void)invertArray;
- (void)randomReal;
- (void)rectToPolar:(id)aMod;
- (void)polarToRect:(id)aMod;
- (void)displaceBigArrayBy:(NSPoint)p;
- (void)walshAction:(int)oneDim;
- (void)fWalsh:(double*)s;
- (void)enterXCoord:(int)x;
- (void)enterYCoord:(int)x;
- (void)enterRCoord:(int)x;
-(void)enterR2Coord:(int)x;
- (void)enterTheta:(int)x;

@end
