/* CODocWinController */

#import <Cocoa/Cocoa.h>
#import "COWorkingView.h"
#import "CODocument.h"
#import "COComplexArray.h"
#import "COWindowMain.h"

@interface CODocWinController : NSWindowController
{
	IBOutlet  NSColorWell *cWell;
	IBOutlet  id theView;
	IBOutlet  NSPopUpButton *viewOptions;
	IBOutlet  NSTextField *xCoordinate;
	IBOutlet  NSTextField *yCoordinate;
	IBOutlet  NSTextField *showRealPart;
	IBOutlet  NSTextField *showImPart;
	IBOutlet  NSTextField *showTheMag;
	IBOutlet  NSTextField *showThePhase;
	IBOutlet  NSTextField *showGrayValue;
	IBOutlet  NSStepper *scaleStepper;
	IBOutlet  NSTextField *scaleDisplay;
	IBOutlet  NSButton *bwButton;
	IBOutlet	NSButton *anySize;
	int			invertColor;
	int			colorize;
	id	coWindow;
	NSBitmapImageRep *bitmapImage;
	id coCompArray;
	id theDoc;
//	id theDrawerC;
	int num;
	int	scale;
	int grayV;
	int hideLiteralButton;
	float histoData[256];
	double histoCutOff;
	int oldX,oldY;
// --- variables from DrawerController ----
	IBOutlet NSColorWell *cDrawerWell;
	IBOutlet NSDrawer *theDrawer;
	IBOutlet NSTabView *theDoubleView;
	IBOutlet id histoView;
	IBOutlet NSView *theContent;
//	IBOutlet NSButton *histoButton;
	IBOutlet NSTextField *topValue;
	IBOutlet NSTextField *cutOffValue;
    IBOutlet NSTextField *limitValueField;
	IBOutlet NSButtonCell *pencilButton;
	IBOutlet NSButtonCell *pencilErasorButton;
	IBOutlet NSButtonCell *brushButton;
	IBOutlet NSButtonCell *erasorButton;
	IBOutlet NSButtonCell *magnifyButton;
	IBOutlet NSButtonCell *grabberButton;
	IBOutlet NSMatrix	*drawingButtons;
	IBOutlet NSButton   *drawingModeButton;
	IBOutlet NSButton	*truncFmAbvButton,*truncFmBlowButton;
	IBOutlet NSButton   *literalButton;
	float clickYPoint;
	int drawingMode;
	int literalMap,show0to255;
    BOOL bwMode;
    double limitValue;
	NSCursor *handOpen,*magniCirsor,*pencilCursor,*pencilCursorErasor,*erasorCursor,*spungeCursor;
	NSCursor *oldCursor,*shifterCursor,*magniCirsorN;
	int		xCoordPt,yCoordPt;
	double	realPrtPt,imPrtPt,magPt,phasePt;
	
	}

- (id)initWithNum:(int)N;
- (float *)histoData;
- (IBAction)viewOpCange:sender;
- (IBAction)fourierF:sender;
- (IBAction)fourierInv:sender;
- (IBAction)enter1_0:sender;
- (IBAction)enter1_1:sender;
- (IBAction)enterGray:sender;
- (IBAction)enterAdd:sender;
- (IBAction)scaleStepperChanged:sender;
- (IBAction)zonalLens:sender;
- (IBAction)bigFile:sender;
- (IBAction)binaryFile:sender;
- (IBAction)startScript:(id)sender;
- (IBAction)continueWithScript:sender;
- (IBAction)stopSingleStep:(id)sender;
- (IBAction)bringDoc:(id)sender;
- (int)num;
- (int)histoCutOff;
- (id)bwButton;
- (NSButton *)anySize;
- (id)viewOptions;
// - (void)setNum:(int)n;
- (void)setCoCompArray:(id)x;
- (id)theDoc;
- (void)setTheDoc:(id)x;
- (NSCursor *) magniCirsor;
- (NSCursor *) magniCirsorN;
- (int)invertColor;
- (void)setInvertColor:(int)x;
- (int)colorize;
- (void)setColorize:(int)x;
- (void)setHistoCutOff:(double)n;
- (void)setOldXY:(NSPoint)p;
- (void)takeBinaryData:(NSData *)fileData;
- (void)takeOddSizeBinaryData:(NSData *)fileData;
- (void)makeFatmap:(unsigned char *)map fromBinary:(NSData *) bitMapRaw;
- (NSData *)binaryFromTheFatmap;
- (void)putTheBytesIn:(NSMutableData *)theBytes;
- (IBAction)filterTheBytes:(id)sender;
- (void)multiplyBytesByBitFile:(NSData *)fileData;
- (id) theView;
- (void)copyCO;
- (void)copyNCo:(id)sender;
- (int)xCoordPt;
- (int)yCoordPt;
- (double)realPrtPt;
- (double)imPrtPt;
- (double)magPt;
- (double)phasePt;
- (int)grayV;
- (void)setXCoordPt:(int)x;
- (void)setYCoordPt:(int)x;
- (void)setRealPrtPt:(double)x;
- (void)setImPrtPt:(double)x;
- (void)setMagPt:(double)x;
- (void)setPhasePt:(double)x;
- (void)setGrayV:(int)x;
- (void)showCoordinates:(NSPoint)aPoint;
- (void)setCoWindow:(id)x;
- (id)coWindow;
//- (id)theDrawerC;
- (void)bringCoWindowFront;
- (id)bitmapImage;
- (unsigned char *)bitmapBytes;
- (void)setImageIntoTheWindow:(unsigned char *)loadedImage spp:(int)s;
//- (void)invertImageColor;
- (void)clearScreen;
//- (NSButton *)screenButton;
- (void)turnedOffButton;
- (IBAction)drawingPenButton;
- (void)drawingErasingPencil;
- (void)drawingEraser;
- (void)drawingBrush;
- (void)magnifier;
- (void)grabber;
- (void)slideScreen;
- (void)displaceTheSavedBy:(NSPoint)p;
- (NSPoint)getCoordinates:(NSPoint)p;
- (void)slideBig;
- (IBAction)scriptWindow:(id)sender;
- (IBAction)COHelpWindow:(id)sender;
@end

@interface CODocWinController (CODrawerController)

// ---- from DrawerController -----
- (BOOL)bwMode;
- (void)setBwMode:(BOOL)x;
- (void) setUpTheDrawer;
- (IBAction)drawerTog:sender;
- (void)doHistogram;
- (id)theDoubleView;
- (id)theDrawer;
- (id)histoView;
- (int)drawingMode;
- (void)clickInHisto;
- (void)setClickYPoint:(float)x;
- (int)literalMap;
- (void)setLiteralMap:(int)x;
- (int)show0to255;
- (void)setShow0to255:(int)x;
- (double)limitValue;
- (void)setLimitValue:(double)x;
- (int)hideLiteralButton;
- (void)setHideLiteralButton:(int)x;
- (IBAction)enteredCutOff:(id)sender;
- (IBAction)truncFmAbv:(id)sender;
- (IBAction)truncFmBlow:(id)sender;
- (IBAction)clipHisto:(id)sender;
- (IBAction)turnOFFButton:(id)sender;
- (IBAction)turnOnPencil:(id)sender;
- (IBAction)turnOnPencilErasor:(id)sender;
- (IBAction)turnOnErasor:(id)sender;
- (IBAction)turnOnBrush:(id)sender;
- (IBAction)turnOnMagnifier:(id)sender;
- (IBAction)turnOnGrabber:(id)sender;
- (IBAction)turnOnSlider:(id)sender;
- (IBAction)turnOnBigSlider:(id)sender;
@end
