/* COZonalControler */

#import <Cocoa/Cocoa.h>
#import "COComplexArray.h"
#import "CODocument.h"

@interface COZonalController : NSWindowController
{
    IBOutlet NSButton *cConjugate;
    IBOutlet NSTextField *focalLength;
    IBOutlet NSButton *multiplyBig;
    IBOutlet NSButton *oneDim;
	IBOutlet NSMatrix *xyChooser;
    IBOutlet NSTextField *pixelSpace;
    IBOutlet NSTextField *waveLength;
    IBOutlet NSTextField *xOffset;
    IBOutlet NSTextField *yOffset;
	IBOutlet NSWindow *zWindow;
	IBOutlet NSColorWell *cWell;
	IBOutlet NSButton *makeZonalButton;
	IBOutlet NSButton *CancelButton;
//  the values extracted from above
	int num;
	int conjFlag;
	int oneDimFlag;
	int multiplyFlag;
	BOOL runningFromModule;
	id theMod;
	double focalL;
	double waveL,oldWaveL;
	double pixelS,oldPixels;
	float dx;
	float dy;
	int oneDimState;
	int multiplyBigState;
	int conjFlagState;
	int xyState;
	int dualState;
	id coCompArray;
	id theDoc;
	id coWinC;
	int batchFlag;
	int consoleFlag;
    BOOL nonparaxial;
	BOOL stepSymbolOn, wlSymbolOn,pixPitchSymbolOn,okSymbols,xDispOn,yDispOn;
	IBOutlet NSTextField *stepSym, *wlSym, *pitchSym;
	NSString *stepSt, *wlSt, *pitchSt;
    NSMutableData *rePhase,*imPhase,*reNonPar,*imNonPar;
	NSWindow* coWindow;
	NSString	*coKeyZPFLambda, *coKeyZPFdistance, *coKeyZPFsepD, *coKeyZPFsep2d;
	NSString	*coKeyZPFcenX, *coKeyZPFcenY,*coKeyZPFxyChooser,*coKeyZPFoneDim;
	NSString	*coKeyZPFwindow,*coKeyZPFcConjugate,*coKeyZPFmultiplyBig;
    NSString *xDisSym,*yDisSym;
}
@property BOOL xDispOn,yDispOn;
@property (retain) NSString *xDisSym,*yDisSym;
- (IBAction)cancelZone:(id)sender;
- (IBAction)makeZonal:(id)sender;
- (IBAction)oneDimChanged:(id)sender;
-(IBAction)bringDoc:(id)sender;
//- (IBAction)preserveDefaultValues:sender;
- (id)initWithNum:(int)N docClass:(id)aDoc;
- (id)initWithDoc:(id)aDoc andNum:(int)N andModule:(id)aMod;
- (BOOL) finishInitWithCoderforModule:(id)aMod;
- (BOOL)okSymbols;
- (void)setOkSymbols:(BOOL)x;
- (id)theDoc;
- (float) focalL;
- (void)setFocalL:(float)x;
- (float) waveL;
- (void) setWaveL:(float)x;
- (float) pixelS;
- (void) setPixelS:(float)x;
- (float) dx;
- (void) setDx:(float)x;
- (float) dy;
- (void) setDy:(float)y;
- (int) oneDimState;
- (void)setOneDimState:(int)x;
- (int)multiplyBigState;
- (void)setMultiplyBigState:(int)x;
- (int)conjFlagState;
- (void)setConjFlagState:(int)x;
- (int)xyState;
- (void)setXyState:(int)x;
- (int)dualState;
- (void)setDualState:(int)x;
- (int)batchFlag;
- (void)setBatchFlag:(int)x;
- (int)consoleFlag;
- (void)setConsoleFlag:(int)x;
- (BOOL)nonparaxial;
- (void)setNonParaxial:(BOOL)x;
- (BOOL)stepSymbolOn;
- (void)setStepSymbolOn:(BOOL)x;
- (BOOL)wlSymbolOn;
- (void)setWlSymbolOn:(BOOL)x;
- (BOOL)pixPitchSymbolOn;
- (void)setPixPitchSymbolOn:(BOOL)x;
- (IBAction)helpZonal:(id)sender;
- (void)defineDefaultKeys;
- (void)readDefaults;
- (void)doTheZonal;
- (BOOL)runningFromModule;
- (void)setRunningFromModule:(BOOL)x;
- (NSTextField*)stepSym;
- (NSTextField*)wlSym;
- (NSTextField*)pitchSym;
- (NSString*)stepSt;
- (void)setStepSt:(NSString*)x;
- (NSString*)wlSt;
- (void)setWlSt:(NSString*)x;
- (NSString*)pitchSt;
- (void)setPitchSt:(NSString*)x;
- (void)cleanUp;
@end
